<template>
   <div class="flex-table workflow" id="workflow-list">
      <div v-for="(w, i) in workflows" :key="`workflow-${i}`"
         class="item-bloc">

         <div>
            <div class="item-row col">
               <h2>{{ w.title }}</h2>
               <div class="flex-grow-1 ms-3 h3">
                  <div class="visually-hidden">
                     {{ w.relatedEntityClass }}
                     {{ w.relatedEntityId }}
                  </div>
               </div>
            </div>

            <div class="breadcrumb">
               <template v-for="(step, j) in w.steps" :key="`step-${j}`">
                  <span class="mx-2"
                     tabindex="0"
                     data-bs-trigger="focus hover"
                     data-bs-toggle="popover"
                     data-bs-placement="bottom"
                     data-bs-custom-class="workflow-transition"
                     :title="getPopTitle(step)"
                     :data-bs-content="getPopContent(step)">

                     <i v-if="step.currentStep.name === 'initial'"
                        class="fa fa-circle me-1 text-chill-yellow">
                     </i>
                     <i v-if="step.isFreezed"
                        class="fa fa-snowflake-o fa-sm me-1">
                     </i>
                     {{ step.currentStep.text }}
                  </span>
                  <span v-if="j !== Object.keys(w.steps).length - 1">
                     →
                  </span>
               </template>
            </div>
         </div>

         <div class="item-row">
            <div class="item-col flex-grow-1">
               <p v-if="isUserSubscribedToStep(w)">
                  <i class="fa fa-check fa-fw"></i>
                  {{ $t('you_subscribed_to_all_steps') }}
               </p>
               <p v-if="isUserSubscribedToFinal(w)">
                  <i class="fa fa-check fa-fw"></i>
                  {{ $t('you_subscribed_to_final_step') }}
               </p>
            </div>
            <div class="item-col">
               <ul class="record_actions">
                  <li>
                     <a :href="goToUrl(w)" class="btn btn-sm btn-show" :title="$t('action.show')"></a>
                  </li>
               </ul>
            </div>
         </div>

      </div>
   </div>
</template>

<script>
import Popover from 'bootstrap/js/src/popover';

const i18n = {
   messages: {
      fr: {
         you_subscribed_to_all_steps: "Vous recevrez une notification à chaque étape",
         you_subscribed_to_final_step: "Vous recevrez une notification à l'étape finale",
         by: "Par",
         at: "Le"
      }
   }
}

export default {
   name: "ListWorkflow",
   i18n: i18n,
   props: {
      workflows: {
         type: Array,
         required: true,
      }
   },
   methods: {
      goToUrl(w) {
         return `/fr/main/workflow/${w.id}/show`;
      },
      getPopTitle(step) {
         if (step.transitionPrevious != null) {
            //console.log(step.transitionPrevious.text);
            let freezed = step.isFreezed ? `<i class="fa fa-snowflake-o fa-sm me-1"></i>` : ``;
            return `${freezed}${step.transitionPrevious.text}`;
         }
      },
      getPopContent(step) {
         if (step.transitionPrevious != null) {
            return `<ul class="small_in_title">
              <li><span class="item-key">${i18n.messages.fr.by} : </span><b>${step.transitionPreviousBy.text}</b></li>
              <li><span class="item-key">${i18n.messages.fr.at} : </span><b>${this.formatDate(step.transitionPreviousAt.datetime)}</b></li>
              </ul>`
            ;
         }
      },
      formatDate(datetime) {
         return datetime.split('T')[0] +' '+ datetime.split('T')[1].substring(0,5)
      },
      isUserSubscribedToStep(w) {
         // todo
         return false;
      },
      isUserSubscribedToFinal(w) {
         // todo
         return false;
      },
   },
   mounted() {
      const triggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'));
      const popoverList = triggerList.map(function (el) {
         //console.log('popover', el)
         return new Popover(el, {
            html: true,
         });
      });
   }
}
</script>
